#include <string.h>
#include "bmsfel_p.h"

//################################################
// BmsObject̃Rei

BmsBuffer::BmsBuffer( int length ) {
  this->length = length;
  this->obj_array = new BmsWord[length];
}

// fXgN^
BmsBuffer::~BmsBuffer() {
  delete [] this->obj_array;
}

//////////////////////////////////////////////////
// getn
int BmsBuffer::get_length() const {
  return this->length;
}

int BmsBuffer::get_count() const {
  int count = 0;
  for ( int i = 0; i < this->length; ++i ) {
    if ( this->obj_array[i] != "00" ) { ++count; }
  }
  return count;
}


//////////////////////////////////////////////////
// IuWF񑀍n

// Q nthlengthȏȂ"00"̃IuWFԂ
BmsWord BmsBuffer::at( int nth ) const {
  if ( nth >= this->length ) { return BmsWord(); }
  return this->obj_array[nth];
}

// ㏑
// nth  length ȏ̒lƉ"00"̃IuWFԂ
// ߂l͏㏑OɃIuWF
BmsWord BmsBuffer::overwrite( int nth, BmsWord obj ) {
  if ( nth >= this->length ) { return BmsWord(); }

  BmsWord return_obj;
  return_obj = this->obj_array[nth];
  this->obj_array[nth] = obj;
  return return_obj;
}

// 폜 "00"̃IuWFl߂
// ߂l͍폜̂"00"ȊÕIuWFǂ
bool BmsBuffer::delete_at( int nth ) {
  if ( nth >= this->length ) { return false; }
  
  bool return_value = false;
  if ( obj_array[nth] != "00" ) { return_value = true; }
  obj_array[nth].set( "00" );
  return return_value;
}

// SĂɑ΂delete_at() ߂l͎ۂdelete
int BmsBuffer::clear() {
  int deleted_num = 0;
  for ( int i = 0; i < this->length; ++i ) {
    if ( this->delete_at( i ) ) { ++deleted_num; }
  }
  return deleted_num;
}


//////////////////////////////////////////////////
// IuWF𕶎ɕϊ ߂l͎ۂɕϊ̑傫
// |C^̐ length * 2 傫ȗ̈pӂ邱
int BmsBuffer::to_str( char *str ) const {
  int step = this->length;
  int str_position = 0;

  // ΂ԊuvZ
  for ( int i = 1; i < this->length; ++i ) {
    if ( obj_array[i] != "00" ) {
      step = BmsUtil::gcd( step, i );
    }
  }

  for ( int i = 0; i < this->length; i += step ) {
    obj_array[i].get_char( &str[str_position], &str[str_position + 1] );
    str_position += 2;
  }

  return str_position;
}

// Ō'\0't length * 2 + 1 傫ȗ̈pӂ邱
int BmsBuffer::to_str_null( char *str ) const {
  int temp = this->to_str( str );
  str[temp] = '\0';
  return temp;
}

//////////////////////////////////////////////////
// IuWFɕϊ ߂l͕ϊ̒
// Ō'\0'Kv
int BmsBuffer::input_str( char *str ) {
  return this->input_n_str( strlen( str ), str );
}

// n = ̒
int BmsBuffer::input_n_str( int n, char *str ) {
  if ( n == 0 || ( n % 2 ) == 1 || ( n / 2 ) > this->length ) { return 0; }

  int str_position = 0;
  int step = this->length / ( n / 2 );
  for ( int i = 0; i < this->length; i += step ) {
    this->overwrite( i, BmsWord( &str[str_position] ) );
    str_position += 2;
  }
  return str_position;
}

//////////////////////////////////////////////////
// IuWF nthwł̏ꏊ Cvbg"00"Ȃ獡܂ł̂L
//  : "FF00FF00".marge( "0000DDDD" ) => "FF00DDDD"
// ߂l͏㏑ďIuWF("00"͊܂܂Ȃ)
// input_bufferdelete͈ڂȂ
int BmsBuffer::merge( BmsBuffer *input_buffer ) {
  return this->merge( 0, input_buffer );
}

int BmsBuffer::merge( int nth, BmsBuffer *input_buffer ) {
  if ( input_buffer == NULL_BUFFER ) { return 0; }
  int deleted_num = 0;

  for ( int i = 0; ; ++i ) {
    if ( i > nth + this->length ) { break; }
    if ( i > input_buffer->get_length() ) { break; }

    if ( input_buffer->at( i ) != "00" ) {
      BmsWord temp = this->overwrite( nth + i, input_buffer->at( i ) );
      if ( temp != "00" )  { ++deleted_num; }
    }
  }
  return deleted_num;
}

// input_bufferdelete
int BmsBuffer::push_in( BmsBuffer *input_buffer ) {
  return this->push_in( 0, input_buffer );
}

int BmsBuffer::push_in( int nth, BmsBuffer *input_buffer ) {
  int return_value = this->merge( nth, input_buffer );
  if ( input_buffer != NULL_BUFFER ) { delete input_buffer; }
  return return_value;
}

//////////////////////////////////////////////////
// IuWF؂oăRs[ ̕BmsBufferԂ neŵdelete͌Ăяo
// fromto(܂)܂ fromtoNULL_BUFFERԂ
BmsBuffer *BmsBuffer::slice_to( int from, int to ) const {
  if ( to - from < 0 ) { return NULL_BUFFER; }
  return this->slice_length( from, to - from + 1 );
}

// fromlength̒ length0菬NULL_BUFFERԂ
// fromRs[length傫ƉRs[ȂBmsBufferԂ
BmsBuffer *BmsBuffer::slice_length( int from, int length ) const {
  if ( from < 0 ) { return NULL_BUFFER; }

  BmsBuffer *temp = new BmsBuffer( length );
  for ( int i = 0; ; ++i ) {
    if ( i > from + this->length ) { break; }
    if ( i > temp->get_length() ) { break; }

    if ( this->at( from + i ) != "00" ) {
      temp->overwrite( i, this->at( from + i ) );
    }
  }
  return temp;
}

//////////////////////////////////////////////////
// ̃IuWF܂ł邩ǂ
bool BmsBuffer::contains( BmsWord word ) {
  for ( int i = 0; i < this->length; ++i ) {
    if ( this->at( i ) == word ) { return true; }
  }
  return false;
}
